size ,samplerate ,bitdepth ,channels ,buffers =
512  ,44100      ,16       ,1        ,3

bufs_per_ms = (samplerate / 1000) / size

function love.load()
	sdata  = love.sound.newSoundData(size, samplerate, bitdepth, channels)
	source = love.audio.newQueueableSource(samplerate, bitdepth, channels, buffers)

	love.graphics.setFont(love.graphics.newFont('FSEX300.ttf', 16))
end

local count, bufs
local phase = 0.0
local remainder = 0.0
function love.update(dt)

	dt = dt * 1000
	bufs  = dt * bufs_per_ms
	remainder = remainder + bufs
	count = source:getFreeBufferCount()

	--print(
	--	string.format('%.2f', dt)..' ms'
	--	..'   expected: '..string.format('%.2f', bufs)
	--	..'   got: '..(count>0 and count or ' ')
	--	..'   remains: '..string.format('%.2f', remainder)
	--)

	for _=1,count do
	--while source:getFreeBufferCount() > 0 do

		for smp=0,size-1 do
			phase = phase + (220.00 / samplerate) % 1.0
			sdata:setSample(smp, math.sin(2.0 * math.pi * phase))
		end

		source:queue(sdata)
		source:play()
	end
	remainder = remainder - count
end

function love.draw()
	love.graphics.print('dt       =', 0, 0)
	love.graphics.print('expected =', 0, 12)
	love.graphics.print('realtime =', 0, 24)
	love.graphics.print('remaindr =', 0, 36)
	love.graphics.printf(string.format('%.4f ms', love.timer.getDelta()), 32, 0, 200, 'right')
	love.graphics.printf(string.format('%.4f buffers', bufs), 32, 12, 200, 'right')
	love.graphics.printf(string.format('%.4f buffers', count), 32, 24, 200, 'right')
	love.graphics.printf(string.format('%.4f buffers', remainder), 32, 36, 200, 'right')
end